> For the complete documentation index, see [llms.txt](https://docs.fringe.fi/v2-smart-contract-documentation/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.fringe.fi/v2-smart-contract-documentation/bondtroller/bondtrollerv3storage.md).

# BondtrollerV3Storage

## Overview

#### License: MIT

```solidity
contract BondtrollerV3Storage is BondtrollerV2Storage
```

## Structs info

### CompMarketState

```solidity
struct CompMarketState {
	uint224 index;
	uint32 block;
}
```

## State variables info

### allMarkets (0x52d84d1e)

```solidity
contract BToken[] allMarkets
```

A list of all markets

### compRate (0xaa900754)

```solidity
uint256 compRate
```

The rate at which the flywheel distributes COMP, per block

### compSpeeds (0x1d7b33d7)

```solidity
mapping(address => uint256) compSpeeds
```

The portion of compRate that each market currently receives

### compSupplyState (0x6b79c38d)

```solidity
mapping(address => struct BondtrollerV3Storage.CompMarketState) compSupplyState
```

The COMP market supply state for each market

### compBorrowState (0x8c57804e)

```solidity
mapping(address => struct BondtrollerV3Storage.CompMarketState) compBorrowState
```

The COMP market borrow state for each market

### compSupplierIndex (0xb21be7fd)

```solidity
mapping(address => mapping(address => uint256)) compSupplierIndex
```

The COMP borrow index for each market for each supplier as of the last time they accrued COMP

### compBorrowerIndex (0xca0af043)

```solidity
mapping(address => mapping(address => uint256)) compBorrowerIndex
```

The COMP borrow index for each market for each borrower as of the last time they accrued COMP

### compAccrued (0xcc7ebdc4)

```solidity
mapping(address => uint256) compAccrued
```

The COMP accrued but not yet transferred to each user


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.fringe.fi/v2-smart-contract-documentation/bondtroller/bondtrollerv3storage.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
